<?php

class QuickEnquiryWidget extends Widget 
{ 
    static $title = "Quick Enquiry"; 
    static $cmsTitle = "Quick Enquiry"; 
    static $description = "A Quick Enquiry Form"; 

    static $db = array(
       // "ButtonText" => "Varchar"
    );

    static $defaults = array(
      //  "ButtonText" => "Sign Me Up!"
    );
    
    public function populateDefaults() {
    parent::populateDefaults();
    //$this->FacebookURL = SiteConfig::current_site_config()->FacebookURL;
	}

    public function getCMSFields() {
      return new FieldList(
           // new TextField("ButtonText", "Submit Button Text")
      );
    }
    
   public function doQuickEnquiryWidget() {

    //Requirements::themedCSS('quickenquiry');

   return;//QuickEnquiryWidget_Controller::QuickEnquiryForm();

   }
   
   
   
   
   
   
   

   
   

}

class QuickEnquiryWidget_Controller extends Widget_Controller 
{ 
   
 //This bypases the WidgetHolder.ss File and only uses the specifice template .ss file
 //Its good for  when you need to control exactly where your heading gets rendered in the widget output 
 	//function WidgetHolder() {
  	//	return $this->renderWith("QuickEnquiryWidget");
 	//} 
     
     protected static $default_mailto = '';
     
     protected static $default_subtext = '';
     
	 public static function set_quicksubject( $subtext = ''){
		 if ($subtext) self::$default_subtext = $subtext;
	 }
     public static function set_mailto($mail = '') {
         if ($mail) self::$default_mailto = $mail;
     }
     
     static $allowed_actions = array(
     		'QuickEnquiryForm'
     	);
     	
     	function QuickEnquiryForm() {
     	 	
     	//->addExtraClass('largeText');
           	$fields = new FieldList(
           	
           	//DropdownField::create('Title','Title', array(''=>'Select','mr'=>'Mr','mrs'=>'Mrs','miss'=>'Miss','ms'=>'Ms','dr'=>'Dr',))->addExtraClass("input-small"),
               TextField::create('Name', "Name")->addExtraClass("input-small"),
               TextField::create("ContactTel", "Contact Telephone")->addExtraClass("input-small"),
               EmailField::create('Email', 'Email')->addExtraClass("input-small"),
               TextareaField::create('Comments','Further Information')->addExtraClass("input-small")
     		);
     	 	
     	    $actions = new FieldList(
     	     FormAction::create('SendQuickEnquiry', 'Send')->setStyle("primary")
     	    );
     	    
     	    $validator = new RequiredFields('FirstName', 'Surname', 'Email', 'Comments');
     		
             $cform = new BootstrapForm($this, 'QuickEnquiryForm', $fields, $actions, $validator);
             $cform->addExtraClass("quickenquiry-widget")->setLayout("horizontal");
     	    $fieldMap = array( 'Name' => 'author_name', 'Surname' => 'author_name','ContactTel' => 'HomeTel', 'Email' => 'author_mail','Comments' => 'post_body');
     	    SpamProtectorManager::update_form($cform, null, $fieldMap);
     	    return $cform;
     	
     	}
      	
     	function SendQuickEnquiry($data, $form) {
     	 
     	 
     //	$mailfrom = Email::getAdminEmail();
     	 $mailfrom = $data['Email'];
     	  //echo  'mailfrom'.$mailfrom.''; 
     	  $mailto = self::$default_mailto;
     	  $mailsubject = self::$default_subtext;
     //	$mailto = QuickEnquiryWidget::$default_mailto;
     	 //echo  'mailto'.$mailto.''; 
     	// get the mailaddrs from the alias or use the default send address
     	  //$mailto = $this->getToAddress($data);
     	    
         	$QuickEnquiry = new QuickEnquiry();
             $QuickEnquiry->SiteTreeID  = $this->ID; 
             $form->saveInto($QuickEnquiry);
             
             if ($QuickEnquiry->write()) {  
             //echo  'write-yess';    
                 if ($mailfrom && $mailto) {
                 //	echo  'yesmailto';
                     /*$contactAddress = array();
                     if ($data['Address1'] != '') {
                         $contactAddress[] = $data['Address1'];
                     }
                     if ($data['Address2'] != '') {
                         $contactAddress[] = $data['Address2'];
                     }
                     if ($data['Address3'] != '') {
                         $contactAddress[] = $data['Address3'];
                     }
                     if ($data['Town'] != '') {
                         $contactAddress[] = $data['Town'];
                     }
                     if ($data['County'] != '') {
                         $contactAddress[] = $data['County'];
                     }
                     if ($data['Postcode'] != '') {
                         $contactAddress[] = $data['Postcode'];
                     }
                     $contactAddressJoined = join('<br>', $contactAddress);*/
                     $emaildata = array(
                         //'ContactName' => $data['Title'] . ' ' . $data['Name'],
                          'ContactName' =>  $data['Name'],
                         'ContactNumber' => $data['ContactTel'],
                         //'ContactAddress' => $contactAddressJoined,
                         'ContactEmail' => $data['Email'],
                         'Comments' => str_replace("\n", "<br>", $data['Comments'])
                     );
                     
                     $From = $mailfrom;
                     $To = $mailto;
                     
                     $Subject = $mailsubject;  	  
                     $email = new Email($From, $To, $Subject);
                     $email->setTemplate('QuickEnquiryEmail');
                     $email->populateTemplate($emaildata);
                     // $email->populateTemplate(Page_Controller::$SiteConfig->Title);
                     $email->send();
                 } else {
                 		//echo  'no-mailto';
                 }
                 
     		} else {
     		
     		//echo  'else';
     			$form->sessionMessage(_t('QUICKENQUIRY_SUBMIT_ERROR', 'There was an error'), 'error');
     		}
     	
     	//3.1
     	// wrong
     //	$mylink = $mypage->URLSegment;
     	// right
     	//$mylink = $mypage->Link(); // alternatively: AbsoluteLink(), RelativeLink()
     		
     		Director::redirect(Director::baseURL().Director::get_current_page()->URLSegment.'/?success=1');
       return;
     	}
     
     	public function Success() {
     		return isset($_REQUEST['success']) && $_REQUEST['success'] == "1";
     	}
     	
         public function init() {
     		parent::init();
     		 Requirements::themedCSS('quickenquiry');
             Requirements::themedCSS('form');
            
             Requirements::set_write_js_to_body(false);
     	}
   
   
   
   
   
   
   
   
   
   
   


  
}